// SPDX-License-Identifier: BUSL-1.1
pragma solidity 0.8.21;

import "@openzeppelin/contracts/token/ERC20/extensions/ERC20Permit.sol";
import "@openzeppelin/contracts/token/ERC20/extensions/ERC20Burnable.sol";

contract MockERC20 is ERC20Permit, ERC20Burnable {
    constructor(uint256 amount) ERC20("erc", "ERC20") ERC20Permit("ERC20"){
        _mint(msg.sender, amount);
    }
    function decimals() public pure override returns (uint8) {
        return 6;
    }
    function transferAndCall(address to, uint256 amount, bytes calldata) external returns (bool success){
        _transfer(msg.sender, to, amount);
    }
}